Index: font-lock.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/lisp/font-lock.el,v
retrieving revision 1.29
diff -u -r1.29 font-lock.el
--- lisp/font-lock.el	2005/01/26 04:18:15	1.29
+++ lisp/font-lock.el	2005/02/10 02:41:21
@@ -436,78 +647,47 @@
   Therefore \"item\" is initially searched for starting from the end of the
   match of \"anchor\", and searching for subsequent instance of \"anchor\"
   resumes from where searching for \"item\" concluded.)
-
-For highlighting single items, typically only MATCH-HIGHLIGHT is required.
-However, if an item or (typically) several items are to be highlighted
-following the instance of another item (the anchor) then MATCH-ANCHORED may be
-required.
-
-These regular expressions should not match text which spans lines.  While
-\\[font-lock-fontify-buffer] handles multi-line patterns correctly, updating when you
-edit the buffer does not, since it considers text one line at a time.
-
-Be very careful composing regexps for this list; the wrong pattern can
-dramatically slow things down!
-")
-;;;###autoload
-(make-variable-buffer-local 'font-lock-keywords)
-
-;;;###autoload
-(defvar font-lock-syntactic-keywords nil
-  "A list of the syntactic keywords to highlight.
-Can be the list or the name of a function or variable whose value is the list.
-See `font-lock-keywords' for a description of the form of this list;
-the differences are listed below.  MATCH-HIGHLIGHT should be of the form:
-
- (MATCH SYNTAX OVERRIDE LAXMATCH)
-
-where SYNTAX can be of the form (SYNTAX-CODE . MATCHING-CHAR), the name of a
-syntax table, or an expression whose value is such a form or a syntax table.
-OVERRIDE cannot be `prepend' or `append'.
-
-For example, an element of the form highlights syntactically:
-
- (\"\\\\$\\\\(#\\\\)\" 1 (1 . nil))
 
- a hash character when following a dollar character, with a SYNTAX-CODE of
- 1 (meaning punctuation syntax).  Assuming that the buffer syntax table does
- specify hash characters to have comment start syntax, the element will only
- highlight hash characters that do not follow dollar characters as comments
- syntactically.
-
- (\"\\\\('\\\\).\\\\('\\\\)\"
-  (1 (7 . ?'))
-  (2 (7 . ?')))
-
- both single quotes which surround a single character, with a SYNTAX-CODE of
- 7 (meaning string quote syntax) and a MATCHING-CHAR of a single quote (meaning
- a single quote matches a single quote).  Assuming that the buffer syntax table
- does not specify single quotes to have quote syntax, the element will only
- highlight single quotes of the form 'c' as strings syntactically.
- Other forms, such as foo'bar or 'fubar', will not be highlighted as strings.
+For highlighting single items, for example each instance of the word
+\"foo\", typically only MATCH-HIGHLIGHT is required.  However, if an item
+or (typically) items are to be highlighted following the instance of
+another item (the anchor), for example each instance of the word \"bar\"
+following the word \"anchor\" then MATCH-ANCHORED may be required.
+
+These regular expressions can match text which spans lines, although it is
+better to avoid it if possible since updating them while editing text is
+slower, and while \\[font-lock-fontify-buffer] handles multi-line patterns
+correctly, updating when you edit the buffer may not, and you may also run into
+problems with support modes like jit-lock or lazy-lock.
+
+This variable is set by major modes via the variable `font-lock-defaults'.
+Be careful when composing regexps for this list; a poorly written pattern can
+dramatically slow things down!")
 
-This is normally set via `font-lock-defaults'."
-)
+;;; XEmacs addition:
 ;;;###autoload
-(make-variable-buffer-local 'font-lock-syntactic-keywords)
+(make-variable-buffer-local 'font-lock-keywords)
 
+;; This variable is used by mode packages that support Font Lock mode by
+;; defining their own keywords to use for `font-lock-keywords'.  (The mode
+;; command should make it buffer-local and set it to provide the set up.)
 (defvar font-lock-defaults nil
-  "The defaults font Font Lock mode for the current buffer.
+  "Defaults for Font Lock mode specified by the major mode.
 Normally, do not set this directly.  If you are writing a major mode,
 put a property of `font-lock-defaults' on the major-mode symbol with
 the desired value.
 
-It should be a list
+Defaults should be of the form:
 
-\(KEYWORDS KEYWORDS-ONLY CASE-FOLD SYNTAX-ALIST SYNTAX-BEGIN)
+ (KEYWORDS KEYWORDS-ONLY CASE-FOLD SYNTAX-ALIST SYNTAX-BEGIN ...)
 
-KEYWORDS may be a symbol (a variable or function whose value is the keywords
-to use for fontification) or a list of symbols.  If KEYWORDS-ONLY is non-nil,
-syntactic fontification (strings and comments) is not performed.  If CASE-FOLD
-is non-nil, the case of the keywords is ignored when fontifying.  If
-SYNTAX-ALIST is non-nil, it should be a list of cons pairs of the form (CHAR
-. STRING) used to set the local Font Lock syntax table, for keyword and
-syntactic fontification (see `modify-syntax-entry').
+KEYWORDS may be a symbol (a variable or function whose value is the keywords to
+use for fontification) or a list of symbols.  If KEYWORDS-ONLY is non-nil,
+syntactic fontification (strings and comments) is not performed.
+If CASE-FOLD is non-nil, the case of the keywords is ignored when fontifying.
+If SYNTAX-ALIST is non-nil, it should be a list of cons pairs of the form
+\(CHAR-OR-STRING . STRING) used to set the local Font Lock syntax table, for
+keyword and syntactic fontification (see `modify-syntax-entry').
 
 If SYNTAX-BEGIN is non-nil, it should be a function with no args used to move
 backwards outside any enclosing syntactic block, for syntactic fontification.
@@ -521,11 +701,30 @@
 `font-lock-keywords', `font-lock-keywords-only',
 `font-lock-keywords-case-fold-search', `font-lock-syntax-table' and
 `font-lock-beginning-of-syntax-function', respectively.
+
+Further item elements are alists of the form (VARIABLE . VALUE) and are in no
+particular order.  Each VARIABLE is made buffer-local before set to VALUE.
 
-Alternatively, if the value is a symbol, it should name a major mode,
-and the defaults for that mode will apply.")
+Currently, appropriate variables include `font-lock-mark-block-function'.
+If this is non-nil, it should be a function with no args used to mark any
+enclosing block of text, for fontification via \\[font-lock-fontify-block].
+Typical values are `mark-defun' for programming modes or `mark-paragraph' for
+textual modes (i.e., the mode-dependent function is known to put point and mark
+around a text block relevant to that mode).
+
+Other variables include that for syntactic keyword fontification,
+`font-lock-syntactic-keywords'
+and those for buffer-specialised fontification functions,
+`font-lock-fontify-buffer-function', `font-lock-unfontify-buffer-function',
+`font-lock-fontify-region-function', `font-lock-unfontify-region-function',
+`font-lock-inhibit-thing-lock' and `font-lock-maximum-size'.")
+;;;###autoload
 (make-variable-buffer-local 'font-lock-defaults)
 
+;; #### OLD COMMENT FROM THE PREVIOUS DOC STRING IN XEMACS:
+;; Alternatively, if the value is a symbol, it should name a major mode,
+;; and the defaults for that mode will apply.
+
 ;; FSF uses `font-lock-defaults-alist' and expects the major mode to
 ;; set a value for `font-lock-defaults', but I don't like either of
 ;; these -- requiring the mode to set `font-lock-defaults' makes it
@@ -534,8 +733,69 @@
 ;; decentralized. (Who knows what strange modes might want
 ;; font-locking?)
 
+; ;; This variable is used where font-lock.el itself supplies the keywords.
+; (defvar font-lock-defaults-alist
+;   (let (;; We use `beginning-of-defun', rather than nil, for SYNTAX-BEGIN.
+; 	;; Thus the calculation of the cache is usually faster but not
+; 	;; infallible, so we risk mis-fontification.  sm.
+; 	(c-mode-defaults
+; 	 '((c-font-lock-keywords c-font-lock-keywords-1
+; 	    c-font-lock-keywords-2 c-font-lock-keywords-3)
+; 	   nil nil ((?_ . "w")) beginning-of-defun
+; 	   (font-lock-mark-block-function . mark-defun)))
+; 	(c++-mode-defaults
+; 	 '((c++-font-lock-keywords c++-font-lock-keywords-1
+; 	    c++-font-lock-keywords-2 c++-font-lock-keywords-3)
+; 	   nil nil ((?_ . "w")) beginning-of-defun
+; 	   (font-lock-mark-block-function . mark-defun)))
+; 	(objc-mode-defaults
+; 	 '((objc-font-lock-keywords objc-font-lock-keywords-1
+; 	    objc-font-lock-keywords-2 objc-font-lock-keywords-3)
+; 	   nil nil ((?_ . "w") (?$ . "w")) nil
+; 	   (font-lock-mark-block-function . mark-defun)))
+; 	(java-mode-defaults
+; 	 '((java-font-lock-keywords java-font-lock-keywords-1
+; 	    java-font-lock-keywords-2 java-font-lock-keywords-3)
+; 	   nil nil ((?_ . "w") (?$ . "w")) nil
+; 	   (font-lock-mark-block-function . mark-defun)))
+; 	(lisp-mode-defaults
+; 	 '((lisp-font-lock-keywords
+; 	    lisp-font-lock-keywords-1 lisp-font-lock-keywords-2)
+; 	   nil nil (("+-*/.<>=!?$%_&~^:" . "w")) beginning-of-defun
+; 	   (font-lock-mark-block-function . mark-defun))))
+;     (list
+;      (cons 'c-mode			c-mode-defaults)
+;      (cons 'c++-mode			c++-mode-defaults)
+;      (cons 'objc-mode			objc-mode-defaults)
+;      (cons 'java-mode			java-mode-defaults)
+;      (cons 'emacs-lisp-mode		lisp-mode-defaults)
+;      (cons 'lisp-mode			lisp-mode-defaults)
+;      (cons 'lisp-interaction-mode	lisp-mode-defaults)))
+;   "Alist of fall-back Font Lock defaults for major modes.
+
+; This variable should not be used any more.
+; Set the buffer-local `font-lock-keywords' in the major mode instead.
+
+; Each item should be a list of the form:
+
+;  (MAJOR-MODE . FONT-LOCK-DEFAULTS)
+
+; where MAJOR-MODE is a symbol and FONT-LOCK-DEFAULTS is a list of default
+; settings.  See the variable `font-lock-defaults', which takes precedence.")
+; (make-obsolete-variable 'font-lock-defaults-alist 'font-lock-defaults)
+
+(defvar font-lock-keywords-alist nil
+  "*Alist of `font-lock-keywords' local to a `major-mode'.
+This is normally set via `font-lock-add-keywords' and
+`font-lock-remove-keywords'.")
+
+(defvar font-lock-removed-keywords-alist nil
+  "*Alist of `font-lock-keywords' removed from `major-mode'.
+This is normally set via `font-lock-add-keywords' and
+`font-lock-remove-keywords'.")
+
 (defvar font-lock-keywords-only nil
-  "Non-nil means Font Lock should not do syntactic fontification.
+  "*Non-nil means Font Lock should not do syntactic fontification.
 This is normally set via `font-lock-defaults'.
 
 This should be nil for all ``language'' modes, but other modes, like
@@ -550,37 +810,97 @@
 (make-variable-buffer-local 'font-lock-keywords-only)
 
 (defvar font-lock-keywords-case-fold-search nil
-  "Whether the strings in `font-lock-keywords' should be case-folded.
-This variable is automatically buffer-local, as the correct value depends
-on the language in use.")
+  "*Non-nil means the patterns in `font-lock-keywords' are case-insensitive.
+This is normally set via `font-lock-defaults'.")
 (make-variable-buffer-local 'font-lock-keywords-case-fold-search)
 
+(defvar font-lock-syntactically-fontified 0
+  "Point up to which `font-lock-syntactic-keywords' has been applied.
+If nil, this is ignored, in which case the syntactic fontification may
+sometimes be slightly incorrect.")
+(make-variable-buffer-local 'font-lock-syntactically-fontified)
+
+(defvar font-lock-syntactic-face-function
+  (lambda (state)
+    (if (nth 3 state)
+	;; XEmacs addition to separate doc-string face from string face
+	;; #### Do we really want to keep doing this?
+	(if (and (= (nth 0 state) 1) ;; depth is 1
+		 (font-lock-lisp-like major-mode))
+	    font-lock-doc-string-face
+	  font-lock-string-face)
+      font-lock-comment-face))
+  "Function to determine which face to use when fontifying syntactically.
+The function is called with a single parameter (the state as returned by
+`parse-partial-sexp' at the beginning of the region to highlight) and
+should return a face.")
+
+;;;###autoload
+(defvar font-lock-syntactic-keywords nil
+  "A list of the syntactic keywords to highlight.
+Can be the list or the name of a function or variable whose value is the list.
+See `font-lock-keywords' for a description of the form of this list;
+the differences are listed below.  MATCH-HIGHLIGHT should be of the form:
+
+ (MATCH SYNTAX OVERRIDE LAXMATCH)
+
+where SYNTAX can be a string (as taken by `modify-syntax-entry'), a syntax
+table, a cons cell (as returned by `string-to-syntax') or an expression whose
+value is such a form.  OVERRIDE cannot be `prepend' or `append'.
+
+For example, an element of the form highlights syntactically:
+
+ (\"\\\\$\\\\(#\\\\)\" 1 \".\")
+
+ a hash character when following a dollar character, with a SYNTAX of
+ \".\" (meaning punctuation syntax).  Assuming that the buffer syntax table does
+ specify hash characters to have comment start syntax, the element will only
+ highlight hash characters that do not follow dollar characters as comments
+ syntactically.
+
+ (\"\\\\('\\\\).\\\\('\\\\)\"
+  (1 \"\\\"\")
+  (2 \"\\\"\"))
+
+ both single quotes which surround a single character, with a SYNTAX of
+ \"\\\"\" (meaning string quote syntax).  Assuming that the buffer syntax table
+ does not specify single quotes to have quote syntax, the element will only
+ highlight single quotes of the form 'c' as strings syntactically.
+ Other forms, such as foo'bar or 'fubar', will not be highlighted as strings.
+
+This is normally set via `font-lock-defaults'.")
+
+;;;###autoload
+(make-variable-buffer-local 'font-lock-syntactic-keywords)
+
+;; XEmacs addition:
 (defvar font-lock-after-fontify-buffer-hook nil
   "Function or functions to run after completion of font-lock-fontify-buffer.")
 
+;; XEmacs addition:
+(defvar font-lock-after-unfontify-buffer-hook nil
+  "Function or functions to run after completion of font-lock-fontify-buffer.")
+
 (defvar font-lock-syntax-table nil
   "Non-nil means use this syntax table for fontifying.
 If this is nil, the major mode's syntax table is used.
 This is normally set via `font-lock-defaults'.")
 (make-variable-buffer-local 'font-lock-syntax-table)
 
-;; These record the parse state at a particular position, always the start of a
-;; line.  Used to make `font-lock-fontify-syntactically-region' faster.
-;; Previously, `font-lock-cache-position' was just a buffer position.  However,
-;; under certain situations, this occasionally resulted in mis-fontification.
-;; I think the "situations" were deletion with Lazy Lock mode's deferral.  sm.
-(defvar font-lock-cache-state nil)
-(defvar font-lock-cache-position nil)
-(make-variable-buffer-local 'font-lock-cache-state)
-(make-variable-buffer-local 'font-lock-cache-position)
-
 ;; If this is nil, we only use the beginning of the buffer if we can't use
 ;; `font-lock-cache-position' and `font-lock-cache-state'.
 (defvar font-lock-beginning-of-syntax-function nil
-  "Non-nil means use this function to move back outside of a syntactic block.
+  "*Non-nil means use this function to move back outside of a syntactic block.
+When called with no args it should leave point at the beginning of any
+enclosing syntactic block.
 If this is nil, the beginning of the buffer is used (in the worst case).
+This is normally set via `font-lock-defaults'.")
+
+(defvar font-lock-mark-block-function nil
+  "*Non-nil means use this function to mark a block of text.
+When called with no args it should leave point at the beginning of any
+enclosing textual block and mark at the end.
 This is normally set via `font-lock-defaults'.")
-(make-variable-buffer-local 'font-lock-beginning-of-syntax-function)
 
 (defvar font-lock-fontify-buffer-function 'font-lock-default-fontify-buffer
   "Function to use for fontifying the buffer.
@@ -607,6 +927,13 @@
 Currently, valid mode names as `fast-lock-mode' and `lazy-lock-mode'.
 This is normally set via `font-lock-defaults'.")
 
+(defvar font-lock-multiline nil
+  "Whether font-lock should cater to multiline keywords.
+If nil, don't try to handle multiline patterns.
+If t, always handle multiline patterns.
+If `undecided', don't try to handle multiline patterns until you see one.
+Major/minor modes can set this variable if they know which option applies.")
+
 ;;;###autoload
 (defcustom font-lock-mode nil ;; customized for the option menu. dverna
   "Non nil means `font-lock-mode' is on"
@@ -617,258 +944,15 @@
   :set #'(lambda (var val) (font-lock-mode (or val 0)))
   )
 
-(defvar font-lock-fontified nil) ; whether we have hacked this buffer
+(defvar font-lock-fontified nil)	; Whether we have fontified the buffer.
 (put 'font-lock-fontified 'permanent-local t)
 
-;;;###autoload
-(defvar font-lock-mode-hook nil
-  "Function or functions to run on entry to font-lock-mode.")
-
-; whether font-lock-set-defaults has already been run.
-(defvar font-lock-defaults-computed nil)
-(make-variable-buffer-local 'font-lock-defaults-computed)
+(defvar font-lock-set-defaults nil)	; Whether we have set up defaults.
+(make-variable-buffer-local 'font-lock-set-defaults)
 
 
-;;; Initialization of faces.
+;; Font Lock mode: The user level functions.
 
-;; #### barf gag retch.  Horrid FSF lossage that we need to
-;; keep around for compatibility with font-lock-keywords that
-;; forget to properly quote their faces.  I tried just let-binding
-;; them when we eval the face expression, but that fails because
-;; some	files actually use the variables directly in their init code
-;; without quoting them. --ben
-(defvar font-lock-comment-face 'font-lock-comment-face
-  "This variable should not be set.
-It is present only for horrid FSF compatibility reasons.
-The corresponding face should be set using `edit-faces' or the
-`set-face-*' functions.")
-(defvar font-lock-doc-string-face 'font-lock-doc-string-face
-  "This variable should not be set.
-It is present only for horrid FSF compatibility reasons.
-The corresponding face should be set using `edit-faces' or the
-`set-face-*' functions.")
-;; GNU compatibility
-(define-compatible-variable-alias
-  'font-lock-doc-face 'font-lock-doc-string-face)
-(defvar font-lock-string-face 'font-lock-string-face
-  "This variable should not be set.
-It is present only for horrid FSF compatibility reasons.
-The corresponding face should be set using `edit-faces' or the
-`set-face-*' functions.")
-(defvar font-lock-keyword-face 'font-lock-keyword-face
-  "This variable should not be set.
-It is present only for horrid FSF compatibility reasons.
-The corresponding face should be set using `edit-faces' or the
-`set-face-*' functions.")
-(defvar font-lock-builtin-face 'font-lock-builtin-face
-  "This variable should not be set.
-It is present only for horrid FSF compatibility reasons.
-The corresponding face should be set using `edit-faces' or the
-`set-face-*' functions.")
-(defvar font-lock-function-name-face 'font-lock-function-name-face
-  "This variable should not be set.
-It is present only for horrid FSF compatibility reasons.
-The corresponding face should be set using `edit-faces' or the
-`set-face-*' functions.")
-(defvar font-lock-variable-name-face 'font-lock-variable-name-face
-  "This variable should not be set.
-It is present only for horrid FSF compatibility reasons.
-The corresponding face should be set using `edit-faces' or the
-`set-face-*' functions.")
-(defvar font-lock-type-face 'font-lock-type-face
-  "This variable should not be set.
-It is present only for horrid FSF compatibility reasons.
-The corresponding face should be set using `edit-faces' or the
-`set-face-*' functions.")
-(defvar font-lock-constant-face 'font-lock-constant-face
-  "This variable should not be set.
-It is present only for horrid FSF compatibility reasons.
-The corresponding face should be set using `edit-faces' or the
-`set-face-*' functions.")
-(defvar font-lock-reference-face 'font-lock-reference-face
-  "This variable should not be set.
-It is present only for horrid FSF compatibility reasons.
-The corresponding face should be set using `edit-faces' or the
-`set-face-*' functions.")
-(defvar font-lock-preprocessor-face 'font-lock-preprocessor-face
-  "This variable should not be set.
-It is present only for horrid FSF compatibility reasons.
-The corresponding face should be set using `edit-faces' or the
-`set-face-*' functions.")
-
-(defconst font-lock-face-list
-  '(font-lock-comment-face
-    font-lock-string-face
-    font-lock-doc-string-face
-    font-lock-keyword-face
-    font-lock-builtin-face
-    font-lock-function-name-face
-    font-lock-variable-name-face
-    font-lock-type-face
-    font-lock-constant-face
-    font-lock-reference-face
-    font-lock-preprocessor-face
-    font-lock-warning-face))
-
-(defface font-lock-comment-face
-  '((((class color) (background dark)) (:foreground "gray80"))
-    ;; blue4 is hardly different from black on windows.
-    (((class color) (background light) (type mswindows)) (:foreground "blue"))
-    (((class color) (background light)) (:foreground "blue4"))
-    (((class grayscale) (background light))
-     (:foreground "DimGray" :bold t :italic t))
-    (((class grayscale) (background dark))
-     (:foreground "LightGray" :bold t :italic t))
-    (t (:bold t)))
-  "Font Lock mode face used to highlight comments."
-:group 'font-lock-faces)
-
-(defface font-lock-string-face
-  '((((class color) (background dark)) (:foreground "tan"))
-    (((class color) (background light)) (:foreground "green4"))
-    (((class grayscale) (background light)) (:foreground "DimGray" :italic t))
-    (((class grayscale) (background dark)) (:foreground "LightGray" :italic t))
-    (t (:bold t)))
-  "Font Lock mode face used to highlight strings."
-:group 'font-lock-faces)
-
-(defface font-lock-doc-string-face
-  '((((class color) (background dark)) (:foreground "light coral"))
-    (((class color) (background light)) (:foreground "green4"))
-    (t (:bold t)))
-  "Font Lock mode face used to highlight documentation strings.
-This is currently supported only in Lisp-like modes, which are those
-with \"lisp\" or \"scheme\" in their name.  You can explicitly make
-a mode Lisp-like by putting a non-nil `font-lock-lisp-like' property
-on the major mode's symbol."
-:group 'font-lock-faces)
-
-(defface font-lock-keyword-face
-  '((((class color) (background dark)) (:foreground "cyan"))
-    ;; red4 is hardly different from black on windows.
-    (((class color) (background light) (type mswindows)) (:foreground "red"))
-    (((class color) (background light)) (:foreground "red4"))
-    (((class grayscale) (background light)) (:foreground "LightGray" :bold t))
-    (((class grayscale) (background dark)) (:foreground "DimGray" :bold t))
-    (t (:bold t)))
-  "Font Lock mode face used to highlight keywords."
-:group 'font-lock-faces)
-
-(defface font-lock-builtin-face
-  '((((class color) (background light)) (:foreground "Purple"))
-    (((class color) (background dark)) (:foreground "Cyan"))
-    (((class grayscale) (background light)) (:foreground "LightGray" :bold t))
-    (((class grayscale) (background dark)) (:foreground "DimGray" :bold t))
-    (t (:bold t)))
-  "Font Lock mode face used to highlight builtins."
-:group 'font-lock-faces)
-
-(defface font-lock-function-name-face
-  '((((class color) (background dark)) (:foreground "aquamarine"))
-    ;; brown4 is hardly different from black on windows.
-    ;; I changed it to red because IMO it's pointless and ugly to
-    ;; use a million slightly different colors for niggly syntactic
-    ;; differences. --ben
-    (((class color) (background light) (type mswindows)) (:foreground "red"))
-    (((class color) (background light)) (:foreground "brown4"))
-    (t (:bold t :underline t)))
-  "Font Lock mode face used to highlight function names."
-:group 'font-lock-faces)
-
-(defface font-lock-variable-name-face
-  '((((class color) (background dark)) (:foreground "cyan3"))
-    (((class color) (background light)) (:foreground "magenta4"))
-    (((class grayscale) (background light))
-     (:foreground "Gray90" :bold t :italic t))
-    (((class grayscale) (background dark))
-     (:foreground "DimGray" :bold t :italic t))
-    (t (:underline t)))
-  "Font Lock mode face used to highlight variable names."
-:group 'font-lock-faces)
-
-(defface font-lock-type-face
-  '((((class color) (background dark)) (:foreground "wheat"))
-    (((class color) (background light)) (:foreground "steelblue"))
-    (((class grayscale) (background light)) (:foreground "Gray90" :bold t))
-    (((class grayscale) (background dark)) (:foreground "DimGray" :bold t))
-    (t (:bold t)))
-  "Font Lock mode face used to highlight types."
-:group 'font-lock-faces)
-
-(defface font-lock-constant-face
-  '((((class color) (background light)) (:foreground "CadetBlue"))
-    (((class color) (background dark)) (:foreground "Aquamarine"))
-    (((class grayscale) (background light))
-     (:foreground "LightGray" :bold t :underline t))
-    (((class grayscale) (background dark))
-     (:foreground "Gray50" :bold t :underline t))
-    (t (:bold t :underline t)))
-  "Font Lock mode face used to highlight constants and labels."
-:group 'font-lock-faces)
-
-(defface font-lock-reference-face
-  '((((class color) (background dark)) (:foreground "cadetblue2"))
-    (((class color) (background light)) (:foreground "red3"))
-    (((class grayscale) (background light))
-     (:foreground "LightGray" :bold t :underline t))
-    (((class grayscale) (background dark))
-     (:foreground "Gray50" :bold t :underline t)))
-  "Font Lock mode face used to highlight references."
-:group 'font-lock-faces)
-
-(defface font-lock-preprocessor-face
-  '((((class color) (background dark)) (:foreground "steelblue1"))
-    (((class color) (background light)) (:foreground "blue3"))
-    (t (:underline t)))
-  "Font Lock Mode face used to highlight preprocessor conditionals."
-:group 'font-lock-faces)
-
-(defface font-lock-warning-face
-  '((((class color) (background light)) (:foreground "Red" :bold t))
-    (((class color) (background dark)) (:foreground "Pink" :bold t))
-    (t (:inverse-video t :bold t)))
-  "Font Lock mode face used to highlight warnings."
-:group 'font-lock-faces)
-
-(defun font-lock-recompute-variables ()
-  ;; Is this a Draconian thing to do?
-  (mapc #'(lambda (buffer)
-	    (with-current-buffer buffer
-	      (font-lock-mode 0)
-	      (font-lock-set-defaults t)))
-	(buffer-list)))
-
-;; Backwards-compatible crud.
-
-(defun font-lock-reset-all-faces ()
-  (dolist (face font-lock-face-list)
-    (face-spec-set face (get face 'face-defface-spec))))
-
-(defun font-lock-use-default-fonts ()
-  "Reset the font-lock faces to a default set of fonts."
-  (interactive)
-  ;; #### !!!!
-  (font-lock-reset-all-faces))
-
-(defun font-lock-use-default-colors ()
-  "Reset the font-lock faces to a default set of colors."
-  (interactive)
-  ;; #### !!!!
-  (font-lock-reset-all-faces))
-
-(defun font-lock-use-default-minimal-decoration ()
-  "Reset the font-lock patterns to a fast, minimal set of decorations."
-  (and font-lock-maximum-decoration
-       (setq font-lock-maximum-decoration nil)
-       (font-lock-recompute-variables)))
-
-(defun font-lock-use-default-maximal-decoration ()
-  "Reset the font-lock patterns to a larger set of decorations."
-  (and (not (eq t font-lock-maximum-decoration))
-       (setq font-lock-maximum-decoration t)
-       (font-lock-recompute-variables)))
-
-
 ;;;;;;;;;;;;;;;;;;;;;;        actual code        ;;;;;;;;;;;;;;;;;;;;;;
 
 ;;; To fontify the whole buffer by language syntax, we go through it a
